/*
 * Rick van der Zwet <info@rickvanderzwet.nl>
 * License BSDLike http://rickvanderzwet.nl/LICENSE
 */

package nl.rickvanderzwet.farmville;

import java.awt.AWTException;
import java.awt.Color;
import java.awt.Point;
import java.awt.PointerInfo;
import java.awt.Robot;
import java.awt.event.InputEvent;
import java.util.Random;
import java.awt.MouseInfo;
import java.io.IOException;



public class Automator {
	
	public enum Direction {
	    UP, DOWN, LEFT, RIGHT
	}

	private static Robot bot = null;
	private static Random randomGenerator = null;
	
	private static void pressMouse() throws InterruptedException {
		bot.mousePress(InputEvent.BUTTON1_MASK);
		// Constant values are tricky, computers can only do that
		Thread.sleep(500 + randomGenerator.nextInt(250));
		bot.mouseRelease(InputEvent.BUTTON1_MASK);
		
	}
	
	private static void moveMouse(Direction direction) throws InterruptedException {
		moveMouse(direction, 200);
	}
	
	private static void moveMouse(Direction direction, Integer sleep_msec) throws InterruptedException {
		/* Relocate to next field */
		PointerInfo pointer = MouseInfo.getPointerInfo();
		
		Integer XMOVE = 24;
		Integer YMOVE = 11; 
		
		Integer x = pointer.getLocation().x;
		Integer y = pointer.getLocation().y;
		
		switch (direction) {
			case UP:
    			bot.mouseMove(x - XMOVE, y - YMOVE);
    			break;
			case DOWN:
    			bot.mouseMove(x + XMOVE, y + YMOVE);
    			break;
			case LEFT:
    			bot.mouseMove(x - XMOVE, y + YMOVE);
    			break;
			case RIGHT:
    			bot.mouseMove(x + XMOVE, y - YMOVE);
    			break;
		}
		Thread.sleep(sleep_msec);
	}
	
	/**
	 * @param args
	 * @throws InterruptedException 
	 * @throws IOException 
	 */
	public static void main(String[] args) throws InterruptedException, IOException {
		try {
			//bot.mouseMove(100, 100);
			bot = new Robot();
			PointerInfo pointer = null;
		    randomGenerator = new Random();
			// Allow time to focus Firefox window
			Thread.sleep(2000);

			int x = 0 ,y = 0;
			/*
			bot.mouseMove(500, 500);
			bot.mousePress(InputEvent.BUTTON1_DOWN_MASK);
			bot.mouseMove(700, 700);
			bot.mouseRelease(InputEvent.BUTTON1_MASK);
			*/
			
			/* Constants */
			Boolean press_mouse = true;
			Integer farm_size_y = 6;
			Integer farm_size_x = 20;
			/* 0 = up, 1 = down, 2 = left, 3 = right */
			
		    if (press_mouse) {
		    	pressMouse();
		    }
		    
		    Direction direction = Direction.UP;
		    
			// Save the mouse button :-)
		    for (int i = 0; i < farm_size_y; i++) {
		    	for (int j = 0; j < farm_size_x; j++) {
		    		pointer = MouseInfo.getPointerInfo();

		    		x = pointer.getLocation().x;
		    		y = pointer.getLocation().y;
		    		System.out.println("x: " + x + ", y: " + y);


		    		/* Too difficult, try larger parts */
		    		Color p = bot.getPixelColor(x, y);	
		    		System.out.println("Pixel color R:" + p.getRed() + ",G:" + 
		    				p.getGreen() + ",B:" + p.getBlue());
		    		
		    		if (press_mouse) {
		    			pressMouse();
		    		}
		    		moveMouse(direction);
		    	}
		    
		    	moveMouse(Direction.LEFT);
		    	
		    	if (direction == Direction.UP) {
		    		direction = Direction.DOWN;
		    	} else {
		    		direction = Direction.UP;
		    	}
		    }
		} catch (AWTException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// TODO Auto-generated method stub

	}



}
